
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InspectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.create(
            {
                id: data.id || undefined,
        
        inspection_number: data.inspection_number
        ||
        null
            ,
            
        inspection_type: data.inspection_type
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
        result: data.result
        ||
        null
            ,
            
        sample_size: data.sample_size
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inspections.setInspection_plan( data.inspection_plan || null, {
            transaction,
        });
        
        await inspections.setMaterial( data.material || null, {
            transaction,
        });
        
        await inspections.setLot( data.lot || null, {
            transaction,
        });
        
        await inspections.setProduction_order( data.production_order || null, {
            transaction,
        });
        
        await inspections.setWork_order_operation( data.work_order_operation || null, {
            transaction,
        });
        
        await inspections.setInspector_user( data.inspector_user || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.inspections.getTableName(),
                belongsToColumn: 'evidence_files',
                belongsToId: inspections.id,
            },
            data.evidence_files,
            options,
        );
        

        return inspections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inspectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                inspection_number: item.inspection_number
            ||
            null
            ,
            
                inspection_type: item.inspection_type
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
                result: item.result
            ||
            null
            ,
            
                sample_size: item.sample_size
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inspections = await db.inspections.bulkCreate(inspectionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < inspections.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.inspections.getTableName(),
                    belongsToColumn: 'evidence_files',
                    belongsToId: inspections[i].id,
                },
                data[i].evidence_files,
                options,
            );
        }
        

        return inspections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const inspections = await db.inspections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.inspection_number !== undefined) updatePayload.inspection_number = data.inspection_number;
        
        
        if (data.inspection_type !== undefined) updatePayload.inspection_type = data.inspection_type;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        if (data.result !== undefined) updatePayload.result = data.result;
        
        
        if (data.sample_size !== undefined) updatePayload.sample_size = data.sample_size;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        updatePayload.updatedById = currentUser.id;

        await inspections.update(updatePayload, {transaction});

        
        
        if (data.inspection_plan !== undefined) {
            await inspections.setInspection_plan(
              
              data.inspection_plan,
              
              { transaction }
            );
        }
        
        if (data.material !== undefined) {
            await inspections.setMaterial(
              
              data.material,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await inspections.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.production_order !== undefined) {
            await inspections.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        
        if (data.work_order_operation !== undefined) {
            await inspections.setWork_order_operation(
              
              data.work_order_operation,
              
              { transaction }
            );
        }
        
        if (data.inspector_user !== undefined) {
            await inspections.setInspector_user(
              
              data.inspector_user,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.inspections.getTableName(),
                belongsToColumn: 'evidence_files',
                belongsToId: inspections.id,
            },
            data.evidence_files,
            options,
        );
        

        return inspections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inspections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inspections) {
                await record.destroy({transaction});
            }
        });


        return inspections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.findByPk(id, options);

        await inspections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inspections.destroy({
            transaction
        });

        return inspections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inspections = await db.inspections.findOne(
            { where },
            { transaction },
        );

        if (!inspections) {
            return inspections;
        }

        const output = inspections.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.nonconformances_inspection = await inspections.getNonconformances_inspection({
            transaction
        });
        
        
        
        output.alerts_related_inspection = await inspections.getAlerts_related_inspection({
            transaction
        });
        
        
        
        
        output.inspection_plan = await inspections.getInspection_plan({
            transaction
        });
        
        
        output.material = await inspections.getMaterial({
            transaction
        });
        
        
        output.lot = await inspections.getLot({
            transaction
        });
        
        
        output.production_order = await inspections.getProduction_order({
            transaction
        });
        
        
        output.work_order_operation = await inspections.getWork_order_operation({
            transaction
        });
        
        
        output.inspector_user = await inspections.getInspector_user({
            transaction
        });
        
        
        output.evidence_files = await inspections.getEvidence_files({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.inspection_plans,
        as: 'inspection_plan',
        
        where: filter.inspection_plan ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspection_plan.split('|').map(term => Utils.uuid(term)) } },
            {
              plan_name: {
                [Op.or]: filter.inspection_plan.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.materials,
        as: 'material',
        
        where: filter.material ? {
          [Op.or]: [
            { id: { [Op.in]: filter.material.split('|').map(term => Utils.uuid(term)) } },
            {
              material_name: {
                [Op.or]: filter.material.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.inventory_lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.work_order_operations,
        as: 'work_order_operation',
        
        where: filter.work_order_operation ? {
          [Op.or]: [
            { id: { [Op.in]: filter.work_order_operation.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.work_order_operation.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'inspector_user',
        
        where: filter.inspector_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspector_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.inspector_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'evidence_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.inspection_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inspections',
                        'inspection_number',
                        filter.inspection_number,
                    ),
                };
            }
            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inspections',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            

            
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sample_sizeRange) {
                const [start, end] = filter.sample_sizeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sample_size: {
                    ...where.sample_size,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sample_size: {
                    ...where.sample_size,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.inspection_type) {
                where = {
                    ...where,
                inspection_type: filter.inspection_type,
            };
            }
            
            if (filter.result) {
                where = {
                    ...where,
                result: filter.result,
            };
            }
            


      

      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inspections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inspections',
                        'inspection_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inspections.findAll({
            attributes: [ 'id', 'inspection_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['inspection_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.inspection_number,
        }));
    }

    
};

